/*!
 * @file shader.h
 * @brief Definition of the Shader rendering class
*/

#ifndef _SHADER_H
#define _SHADER_H

#include "base_object.h"
#include "glincl.h"


typedef enum
{
  SHADER_NONE       = 0,
  SHADER_FRAGMENT   = 1,
  SHADER_VERTEX     = 0,

} SHADER_TYPE;

// FORWARD DECLARATION



//! A class for ...
class Shader : public BaseObject {

 public:
  Shader(SHADER_TYPE type, ...);
  virtual ~Shader();

  bool loadShaderProgramm(SHADER_TYPE type, const char* fileName);
  bool activateShader();

 private:
   char*                  fragmentShaderFile;
   char*                  vertexShaderFile;
   char*                  fragmentShaderSource;
   char*                  vertexShaderSource;
   GLenum                 shaderProgram;
   GLenum                 vertexShader;
   GLenum                 fragmentShader;
};

#endif /* _SHADER_H */
